# coding: utf-8

"""
Copyright (c) 2019 Aspose.Cells Cloud
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
"""


from pprint import pformat
from six import iteritems
import re


class CustomFilter(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'filter_operator_type': 'str',
        'criteria': 'object'
    }

    attribute_map = {
        'filter_operator_type': 'FilterOperatorType',
        'criteria': 'Criteria'
    }
    
    @staticmethod
    def get_swagger_types():
        return CustomFilter.swagger_types
    
    @staticmethod
    def get_attribute_map():
        return CustomFilter.attribute_map
    
    def get_from_container(self, attr):
        if attr in self.container:
            return self.container[attr]
        return None

    def __init__(self, filter_operator_type=None, criteria=None, **kw):
        """
        Associative dict for storing property values
        """
        self.container = {}
		    
        """
        CustomFilter - a model defined in Swagger
        """

        self.container['filter_operator_type'] = None
        self.container['criteria'] = None

        if filter_operator_type is not None:
          self.filter_operator_type = filter_operator_type
        if criteria is not None:
          self.criteria = criteria

    @property
    def filter_operator_type(self):
        """
        Gets the filter_operator_type of this CustomFilter.

        :return: The filter_operator_type of this CustomFilter.
        :rtype: str
        """
        return self.container['filter_operator_type']

    @filter_operator_type.setter
    def filter_operator_type(self, filter_operator_type):
        """
        Sets the filter_operator_type of this CustomFilter.

        :param filter_operator_type: The filter_operator_type of this CustomFilter.
        :type: str
        """

        self.container['filter_operator_type'] = filter_operator_type

    @property
    def criteria(self):
        """
        Gets the criteria of this CustomFilter.

        :return: The criteria of this CustomFilter.
        :rtype: object
        """
        return self.container['criteria']

    @criteria.setter
    def criteria(self, criteria):
        """
        Sets the criteria of this CustomFilter.

        :param criteria: The criteria of this CustomFilter.
        :type: object
        """

        self.container['criteria'] = criteria

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.get_swagger_types()):
            value = self.get_from_container(attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CustomFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
