# coding: utf-8

"""
Copyright (c) 2019 Aspose.Cells Cloud
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
"""


from pprint import pformat
from six import iteritems
import re


class Link(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'href': 'str',
        'type': 'str',
        'rel': 'str',
        'title': 'str'
    }

    attribute_map = {
        'href': 'Href',
        'type': 'Type',
        'rel': 'Rel',
        'title': 'Title'
    }
    
    @staticmethod
    def get_swagger_types():
        return Link.swagger_types
    
    @staticmethod
    def get_attribute_map():
        return Link.attribute_map
    
    def get_from_container(self, attr):
        if attr in self.container:
            return self.container[attr]
        return None

    def __init__(self, href=None, type=None, rel=None, title=None, **kw):
        """
        Associative dict for storing property values
        """
        self.container = {}
		    
        """
        Link - a model defined in Swagger
        """

        self.container['href'] = None
        self.container['type'] = None
        self.container['rel'] = None
        self.container['title'] = None

        if href is not None:
          self.href = href
        if type is not None:
          self.type = type
        if rel is not None:
          self.rel = rel
        if title is not None:
          self.title = title

    @property
    def href(self):
        """
        Gets the href of this Link.

        :return: The href of this Link.
        :rtype: str
        """
        return self.container['href']

    @href.setter
    def href(self, href):
        """
        Sets the href of this Link.

        :param href: The href of this Link.
        :type: str
        """

        self.container['href'] = href

    @property
    def type(self):
        """
        Gets the type of this Link.

        :return: The type of this Link.
        :rtype: str
        """
        return self.container['type']

    @type.setter
    def type(self, type):
        """
        Sets the type of this Link.

        :param type: The type of this Link.
        :type: str
        """

        self.container['type'] = type

    @property
    def rel(self):
        """
        Gets the rel of this Link.

        :return: The rel of this Link.
        :rtype: str
        """
        return self.container['rel']

    @rel.setter
    def rel(self, rel):
        """
        Sets the rel of this Link.

        :param rel: The rel of this Link.
        :type: str
        """

        self.container['rel'] = rel

    @property
    def title(self):
        """
        Gets the title of this Link.

        :return: The title of this Link.
        :rtype: str
        """
        return self.container['title']

    @title.setter
    def title(self, title):
        """
        Sets the title of this Link.

        :param title: The title of this Link.
        :type: str
        """

        self.container['title'] = title

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.get_swagger_types()):
            value = self.get_from_container(attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Link):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
